#include "classeditor.h"
#include "ui_classeditor.h"


ClassEditor::ClassEditor(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ClassEditor)
{
    ui->setupUi(this);
//    settdialog = new SettingsDialog(this);
    settdialog.show();
    sql.setDatabaseName(tr("an_db"));
    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));

    table = new SqlTable (tr("NewTable"), this);
    table->setName(tr("NewTable"));
    table->fields().at(0)->setNotNull(true);
    if (!(table->setPrimaryKey(tr("ID")))) {
         ui->label_3->setText(table->lastError());
    }
    else  ui->label_3->setText(table->primaryKey());
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(" ()"), this);
    field->setNotNull(true);
    field->setType(tr("INTEGER"));
    field->setDefaultValue(tr("1"));
    table->append(field);

    field = new TableField(tr(" "), this);
    field->setNotNull(false);
    field->setType(tr("DATE"));
    field->setDefaultValue(tr("NULL"));
    table->append(field);

    ui->label_2->setText(table->name());
    ui->label->setText(table->fields().at(0)->sqlString());
    ui->label_4->setText(table->sqlString());
   ////// ui->lineEdit->insert(table->sqlString());


    /**********************************************

    QTextDocument *document;
    // = ui->textEdit->document();
    QTextCursor *cursor;

    document = ui->textEdit->document();
    cursor = new QTextCursor(document);
    cursor->movePosition(QTextCursor::Start);
QTextCharFormat format(cursor->charFormat());
//format.setFontFamily("Courier");
format.setFontFamily("Arial");
//format.setFontItalic(false);

format.setFontWeight(QFont::Normal);
QTextCharFormat boldFormat = format;
boldFormat.setFontWeight(QFont::Bold);

QTextCharFormat italicFormat = format;
//format.setFontFamily("Courier");
//     format.setFontFamily("Arial");
italicFormat.setFontItalic(true);

cursor->insertText(table->sqlString(), format);

****************************************************/

QString errorString;

sql.setDatabaseName(tr("an_db"));
sql.setHostName(tr("localhost"));
sql.setUserName(tr("an"));
sql.setPassword(tr("393939"));

bool ok;
ok = sql.connect();
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .





}


ok = sql.createTable(table);
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .
         }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .
     }





ok = sql.createDataBase();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Create"),   // .
                                                    QObject::tr("   ."));         //  .
    }


model = new QSqlTableModel(this);
mymodel = new MyModel(this);


model->setTable(tr("ListOfClasses"));
mymodel->setTable(tr("ListOfClasses"));

/////model->setEditStrategy(QSqlTableModel::OnManualSubmit);

/*
model->setEditStrategy(QSqlTableModel::OnFieldChange);
mymodel->setEditStrategy(QSqlTableModel::OnFieldChange);
*/


model->setSort(0, Qt::AscendingOrder);
mymodel->setSort(0, Qt::AscendingOrder);

//       model->setFilter(tr("__ = '7' and _ = 'i09090909'"));
model->select();
mymodel->select();

model->setHeaderData(1, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(1, Qt::Horizontal, tr(" "));



model->setHeaderData(2, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(2, Qt::Horizontal, tr(" "));

//ui->tableView->setModel(model);
ui->tableView->setModel(mymodel);




ui->tableView->setAlternatingRowColors(true);
ui->tableView->resizeColumnsToContents();
//ui->tableView->hideColumn(0);



}











ClassEditor::~ClassEditor()
{
    delete ui;
 //    delete field;
   // delete settdialog;
}

void ClassEditor::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}



void  ClassEditor::addNewClass(){

    int row = model->rowCount();

    model->insertRows(row, 1);
    model->setData(model->index(row, 1), tr("New class")); //     " "


    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    model->submitAll();

    row = model->rowCount();
    QString tmp_str;
    int i_tmp;
    i_tmp = model->data(model->index(row-1, 0)).toInt();
    tmp_str = model->data(model->index(row-1, 0)).toString(); //   -  

    tmp_str.append(tr("_Inctance"));
    model->setData(model->index(row-1, 3), tmp_str );  //     

    model->submitAll();
    mymodel->select();


}


void  ClassEditor::addNewClass_new(){

    int row = mymodel->rowCount();

    mymodel->insertRows(row, 1);
    mymodel->setData(mymodel->index(row, 1), QVariant(tr("New classs")), Qt::EditRole); //     " "

    mymodel->submitAll();

    row = mymodel->rowCount();
    QString tmp_str1;
    int i_tmp1;
    i_tmp1 = mymodel->data(mymodel->index(row-1, 0)).toInt();
    tmp_str1 = mymodel->data(mymodel->index(row-1, 0)).toString(); //   -  

    tmp_str1.append(tr("_Inctance"));
    mymodel->setData(mymodel->index(row-1, 3), QVariant(tmp_str1), Qt::EditRole);  //     

    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    mymodel->submitAll();

    //row = mymodel->rowCount();


  mymodel->select();


}


void ClassEditor::on_pushButton_clicked(){
//int i;
//i++;
/////ClassEditor::addNewClass();
ClassEditor::addNewClass_new();
 mymodel->select();
//ui->tableView->setModel(mymodel);

}


