#include "sqltable.h"

SqlTable::SqlTable(QString tname, QObject *parent) :
   QObject(parent)
{

    tableName = tname;
    field_tmp = new TableField("ID", this); //      "ID" ()
    field_tmp->setType(tr("INT(10)"));
    field_tmp->setAutoIncrement(true);
    tableFields.append(field_tmp); //    ()   () 
    tablePrimaryKey = field_tmp->name(); //      
    tablePrimaryKeyIndex = 0;
    tableEngine = tr("MyISAM");
    tableCharacterSet = tr("cp1251");
    //delete field_tmp;
}

/***************************************************************************************
**    ,       tname
**
**
***************************************************************************************/


void SqlTable::setName(QString tname){
    SqlTable::tableName = tname;
    SqlTable::createSqlString();
}

/***************************************************************************************
**    
**
**
***************************************************************************************/


QString SqlTable::name(){

    return SqlTable::tableName;
}


/***************************************************************************************
**       
**
**
***************************************************************************************/

QList<TableField*> SqlTable::fields(){

    return SqlTable::tableFields;
}


/***************************************************************************************
**     ,
**       fieldName
**  true,    
**  -  false         lastError
**
**
***************************************************************************************/



bool SqlTable::setPrimaryKey(QString fieldName){

    if (tableFields.isEmpty()) {                                            //    
        SqlTable::tableLastError = tr("Table does not contain fields!");    //  
        return false;
    }
    for (int i = 0; i < tableFields.size(); ++i){
        if (tableFields.at(i)->name() == fieldName){                        //     
            SqlTable::tablePrimaryKeyIndex = i;                                  //      
            SqlTable::tablePrimaryKey = tableFields.at(i)->name();          //     ,    
            SqlTable::createSqlString();                                    //  sql- 
            return true;
        }
    }
    SqlTable::tableLastError = tr("In the table there is no field with that name!");  //      ,
    return false;                                                                     //  
}


/***************************************************************************************
**      ,
**      
**
***************************************************************************************/

QString SqlTable::lastError(){
return SqlTable::tableLastError;
}



/***************************************************************************************
**    ,
**    
**
***************************************************************************************/

QString SqlTable::primaryKey(){
    return SqlTable::tablePrimaryKey;
}

/***************************************************************************************
**    Sql-,
**      e 
**
***************************************************************************************/

bool SqlTable::createSqlString(){
    QString sql_str;
    int i = 0;
    if (tableFields.isEmpty()) {                                            //    
        SqlTable::tableLastError = tr("Table does not contain fields!");    //  
        return false;
    }
    sql_str = tr("CREATE TABLE `");
    sql_str.append( SqlTable::tableName);
    sql_str.append(tr("` ( "));

    for (i; i < (tableFields.size()-1); ++i){  //   ,  
    sql_str.append(tableFields.at(i)->sqlString());
    sql_str.append(tr(", "));
    }
    sql_str.append(tableFields.at(i)->sqlString()); //  
    sql_str.append(tr(" "));                        //       

    if (SqlTable::tablePrimaryKey != tr("")) {      //    ,
        sql_str.append(tr(", "));                   //   
        sql_str.append(tr("PRIMARY KEY  (`"));
        sql_str.append(SqlTable::tablePrimaryKey);
        sql_str.append(tr("`) ) "));
    }
    else  sql_str.append(tr(" ) "));
    if (SqlTable::tableEngine != tr("")) {
        sql_str.append(tr("ENGINE="));
        sql_str.append(SqlTable::tableEngine);
        sql_str.append(tr(" "));
    }
    if (SqlTable::tableCharacterSet != tr("")){
        sql_str.append(tr("DEFAULT CHARSET="));
        sql_str.append(SqlTable::tableCharacterSet);

    }
     SqlTable::SqlString = sql_str;
    return true;

}

/***************************************************************************************
**    Sql-,       
**
**
***************************************************************************************/


QString  SqlTable::sqlString(){
    return  SqlTable::SqlString;

}


void SqlTable::append(TableField* newfield){ //     ()    ,     newfield ()
      SqlTable::tableFields.append(newfield);
      SqlTable::createSqlString();
}
